<?php

/*
attach - прикреплен
detach - откреплен
NULL - в основной группе
*/

class DataArr_Students {
    protected $model;
    
    public function __construct() {
        $this->model = new Model_DataArr_Students;
    }
    
    public function byStudyGroup($groupID)
    {
        $students = $this->model->getStudentsByGroups($groupID);
        return new DataArray_Result($this->generateArray($students));
    }
    
    public function byFaculty($facultyID)
    {
        $students = $this->model->getStudentsByFaculty($facultyID);
        return new DataArray_Result($this->generateArray($students));
    }
    
    public function byGrade($gradeID)
    {
        $students = $this->model->getStudentsByGrade($gradeID);
        return new DataArray_Result($this->generateArray($students));
    }
    
    public function getDegreeTitle($degree)
    {
        switch($degree)
        {
            case 'bachelor': 
            {
                return 'Бакалавриат';
            }
            case 'specialist': 
            {
                return 'Специалитет';
            }
            case 'master': 
            {
                return 'Магистратура';
            }
                
        }
    }
    
    protected function generateArray($students)
    {
        $studentsHandled = array(); $i = 0;
        foreach($students as $row)
        {
            $i++;
            $studentsHandled[$i]['ID'] = $row['ID'];
            $studentsHandled[$i]['LastName'] = $row['LastName'];
            $studentsHandled[$i]['FirstName'] = $row['FirstName'];
            $studentsHandled[$i]['SecondName'] = $row['SecondName'];
            $studentsHandled[$i]['GroupID'] = $row['GroupID'];
            $studentsHandled[$i]['GroupNum'] = $row['GroupNum'];
            $studentsHandled[$i]['GradeID'] = $row['GradeID']; // ID курса
            $studentsHandled[$i]['GradeNum'] = $row['GradeNum']; // НОМЕР курса, а не ID... ID почти всегда <> НОМЕРУ курса
            $studentsHandled[$i]['Degree'] = $this->getDegreeTitle($row['Degree']);
        }
        return $studentsHandled;
    }

    public function NotAttendingDiscipline($GradeID, $GroupID, $FacultyID, $Name, $DisciplineID)
    {
        $students = $this->model->SearchStudents($GradeID, $GroupID, $FacultyID, $Name, $DisciplineID);
        //echo Debug::vars($students);
        return new DataArray_Result($this->generateArray($students));
    }
}
